<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
require_once __DIR__ . '/../../ds4woo/Classes/Tools_DS4.php';
require_once __DIR__ . '/../../wooInterface/WooInterface.php';
require_once __DIR__ . '/../../ds4woo/Kernel/Translations/DigitalSignageTranslate.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

class ParentController extends ModuleAdminController
{
    private $relativeModuleDirPath = '../../../../modules/digitalsignage';

    public function __construct()
    {
        parent::__construct();

        DigitalSignageTranslate::setLang(substr(get_bloginfo('language'), 0, 2));

        $this->bootstrap = true;
        $this->display = 'view';
        $this->context = Context::getContext();
        $this->context->controller->addCSS(get_site_url() . 'modules/digitalsignage/views/css/styles.css');
    }

    public function initContent()
    {
        parent::initContent();
    }

    public function generatePage()
    {
        // TODO: Implement generatePage() method.
    }

    private function getDs4wooControllerContent($controller)
    {
        ob_start();
        if (class_exists($controller)) {
            $controller = new $controller();
            $controller->generatePage();
        } else {
            echo "controller $controller not found";
        }

        return ob_get_clean();
    }

    protected function displayDs4WooControllerContent($string)
    {
        $content = $this->getDs4wooControllerContent($string);
        $this->context->smarty->assign('content', $content);
        $this->setTemplate($this->relativeModuleDirPath . '/views/templates/admin/Content/contentAdapter.tpl');
    }
}
