<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
if (!defined('_PS_VERSION_')) {
    exit;
}

class Shortcode
{
    public static function replaceShortcodes($html)
    {
        if (!ForfaitManager::instance()->getToken()) {
            $forfait = new ForfaitEntity();
            $success = $forfait->fromArray(Wp_caller::getInstance()->get_data(Wp_caller::FORFAIT));

            if ($success) {
                ForfaitManager::instance()->setForfait($forfait);
            }
        }

        $isHeader = true;

        $html = self::replaceShortCodeType($html, 'digitalsignage4', $isHeader);
        $html = self::replaceShortCodeType($html, 'digitalsignage4_playlist', $isHeader);

        return $html;
    }

    private static function replaceShortCodeType($html, $type, $isHeader)
    {
        // remplacement des shortcodes video
        $htmlExplode = explode('[' . $type . ' id=', $html);

        foreach ($htmlExplode as $key => $htmlPart) {
            $htmlPartExplode = explode(']', $htmlPart);

            if (is_array($htmlPartExplode)) {
                if (is_numeric($htmlPartExplode[0])) {
                    if ($isHeader) {
                        $htmlPartExplode[0] = '';
                    } else {
                        if ($type == 'digitalsignage4') {
                            $htmlPartExplode[1] = self::videoShortcode($htmlPartExplode) . $htmlPartExplode[1];
                            array_shift($htmlPartExplode);
                            $htmlPartExplode = [implode(']', $htmlPartExplode)];
                        } else {
                            $htmlPartExplode[0] = self::playlistShortcode($htmlPartExplode);
                        }
                    }
                } else {
                    $htmlPartExplode = [implode(']', $htmlPartExplode)];
                }
            }

            $htmlExplode[$key] = implode('', $htmlPartExplode);
        }

        return implode('', $htmlExplode);
    }

    private static function videoShortcode($htmlPartExplode)
    {
        $videoId = $htmlPartExplode[0];
        $videoData = false;

        $demandeManager = DemandeManager::set(new Wp_caller());
        $videosData = $demandeManager->getLocalDemandes('SELECT * FROM %s WHERE `id_demande` = ' . $videoId . ' LIMIT 1');

        if (!empty($videosData)) {
            $videoData = $videosData[0];
        }

        if ($videoData) {
            $videoModeleClone = self::getVideoModele();
            $videoModeleClone = str_replace('[video_mp4_source]', $videoData->getVideoUrl(), $videoModeleClone);
            $videoModeleClone = str_replace('[video_ogv_source]', $videoData->getVideoUrlOgv(), $videoModeleClone);
            $videoModeleClone = str_replace('[video_alternative_message]', '', $videoModeleClone);

            if (ForfaitManager::instance()->getToken()) {
                return $videoModeleClone;
            }
        }

        return '';
    }

    private static function getVideoModele()
    {
        ob_start();
        ?>
            <video style='max-width: 100%;' muted='muted' loop autoplay='autoplay' preload='auto'>
                <source src='[video_mp4_source]' type='video/mp4'>
                <source src='[video_ogv_source]' type='video/ogg'>
                [video_alternative_message]
            </video><?php
        return ob_get_clean();
    }

    private static function playlistShortcode(array $htmlPartExplode)
    {
        if (!ForfaitManager::instance()->getToken()) {
            return '';
        }

        $random = rand(0, 10000000);
        $playlist = PlaylistManager::set(new Wp_caller())->get_playlist($htmlPartExplode[0]);

        if ($playlist) {
            $videos = $playlist->get_videos();

            if ($videos) {
                return "


              <video id='video_$random' style='max-width: 100%;' muted='muted' autoplay='autoplay'
                           preload='auto'>
                        <source id='mp4_$random' src='' type='video/mp4'/>
                        <source id='ogv_$random' src='' type='video/ogg'/>
                        <p id='alter_$random'></p>
                    </video>
                    <script>

                        let videos = " . json_encode($videos) . ";

                        let video_c = document.getElementById('video_$random');
                        let cpt = 0;

                        lunchVideo(video_c, videos[cpt]);

                        video_c.addEventListener('ended', () => {
                            cpt++;

                            if (cpt >= videos.length) {
                                cpt = 0;
                            }

                            console.log(cpt);

                            lunchVideo(video_c, videos[cpt]);
                        });

                        function lunchVideo(video_c, video) {

                            video_c.currentTime = 0;

                            let video_mp4 = document.getElementById('mp4_$random');
                            let video_ogv = document.getElementById('ogv_$random');
                            let video_alter = document.getElementById('alter_$random');

                            video_mp4.src = '" . Tools_DS4::getModuleUrlPresta() . "videos/' + video.id_demande + '<?= '/video.mp4' ?>';
                            video_ogv.src = '" . Tools_DS4::getModuleUrlPresta() . "videos/' + video.id_demande + '<?= '/video.ogv' ?>';
                            video_alter.innerHTML = video.video_name;

                            video_c.load();
                            video_c.play();

                        }

                    </script>

                   ";
            }
        }

        return '';
    }
}
