<?php
/**
 * CronJobController est un fichier lancer en ajax async depuis le header du site (front + back)
 * Ce fichier permet de récupérer les vidéos depuis l'API ( information + video mp4 et ogv )
 *
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 * Date : 4 Juin 2021
 */

include_once '../../../../config/config.inc.php';

require_once __DIR__ . '/../../wooInterface/WooInterface.php';
/*
require_once __DIR__ . '/../../ds4woo/Kernel/Translations/DigitalSignageTranslate.php';
require_once __DIR__ . '/../../ds4woo/Classes/Wp_caller.php';
require_once __DIR__ . '/../../ds4woo/Classes/Tools_DS4.php';
require_once __DIR__ . '/../../ds4woo/controllers/override/UpdateVideoHandleManager.php';
require_once __DIR__ . '/../../ds4woo/controllers/DigitalSignageController.php';
require_once __DIR__ . '/../../ds4woo/controllers/PresentationController.php';
require_once __DIR__ . '/../../ds4woo/controllers/PlaylistsController.php';
require_once __DIR__ . '/../../ds4woo/controllers/VideoController.php';
require_once __DIR__ . '/../../ds4woo/controllers/GabaritController.php';
require_once __DIR__ . '/../../ds4woo/controllers/ParametreController.php';
require_once __DIR__ . '/../../ds4woo/Kernel/API/Manager/DigitalSignageException.php';
require_once __DIR__ . '/../../controllers/agents/Shortcode.php';
require_once __DIR__ . '/../../ds4woo/Kernel/API/Manager/UpdateManager.php';
*/

require_once __DIR__ . '/../../ds4woo/Kernel/API/Manager/AutomatisationManager.php';

require_once __DIR__ . '/../../ds4woo/Classes/Wp_caller.php';

use kernel\callers\CmsCaller;
use kernel\controllers\GabaritController;
use kernel\controllers\PlaylistController;
use kernel\controllers\UserController;
use kernel\controllers\VideoController;
use kernel\entitys\VideoEntity;

// include_once '../../vendor/autoload.php';
// include_once '../../../../config/config.inc.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

// Point d'entrer de ma methode de cron
new CronJobController();

class CronJobController
{
    private $cronTimeDiffExecution = 20;

    private $databaseSaveFildName = 'DigitalSignage4_cron';

    private $databaseSaveFildNameJour = 'DigitalSignage4_cron_jour_update';

    private $devMode = true; // permet de lancer les request sans attendre les $cronTimeDiffExecution

    public function __construct()
    {
        $this->runJobDay();

        $lastUpdate = (new CmsCaller())->getData($this->databaseSaveFildNameJour);
        if ($lastUpdate !== (int) date('j')) {
            $this->runJobDay();
            (new CmsCaller())->saveData($this->databaseSaveFildNameJour, (int) date('j'));
        }

        // valeur +
        if (($this->getDateUpdate() - $this->getDateLastUpdate()) >= $this->cronTimeDiffExecution
            || ($this->getDateUpdate() - $this->getDateLastUpdate()) < 0 || $this->devMode) {
            $this->setDateLastUpdate();
            $this->runJob();
        }
    }

    private function uploadVideoYoutube($videoUrl)
    {
        // Vérifier que la case à cocher "upload youtube" l'est
        echo 'debut uploadVideoYoutube avec parametre ' . $videoUrl . '<br/>';
        $forfait = ForfaitManager::instance()->getForfait(ForfaitManager::instance()->getToken(), true);
        $dataYoutube = Wp_caller::getInstance()->get_data(Wp_caller::YOUTUBE_JSON);
        // var_dump($dataYoutube);
        if ($forfait && $dataYoutube) {
            $idForfait = $forfait->getId();
            echo 'idForfait : ' . $idForfait . '<br/>';
            echo 'youtube actif : ' . $dataYoutube['youtube_active'] . '<br/>';

            if ($dataYoutube['youtube_active']) {
                // Vérifier que l'état du compte est à 3
                // Donner l'ordre

                $ch = curl_init();
                $responseAPI = $this->callYoutubeAPI(['action' => 'getStatus', 'idForfait' => $idForfait]);

                if ($responseAPI != null) {
                    $jsonAPI = json_decode($responseAPI, true);
                    if ($jsonAPI['response_code'] == 200) {
                        $stateOauth = $jsonAPI['datas']['state'];
                        echo 'state : ' . $stateOauth;
                        if ($stateOauth == 3) {
                            $this->callYoutubeAPI(['action' => 'uploadVideo', 'idForfait' => $idForfait, 'urlVideo' => $videoUrl, 'titleVideo' => 'title', 'summaryVideo' => 'summary']);
                        }
                    }
                }
            }
        }
    }

    private function callYoutubeAPI($datas)
    {
        $ch = curl_init();
        $responseAPI = null;

        try {
            curl_setopt($ch, CURLOPT_URL, 'https://ip120.ip-5-196-165.eu/API_v2/Youtube/');
            curl_setopt($ch, CURLOPT_POST, true);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $datas);
            curl_setopt($ch, CURLOPT_HEADER, false);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 5);
            curl_setopt($ch, CURLOPT_TIMEOUT, 5);
            curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
            curl_setopt($ch, CURLOPT_MAXREDIRS, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, true);

            $response = curl_exec($ch);

            if (curl_errno($ch)) {
                echo curl_error($ch);
                exit;
            }

            $http_code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
            if ((int) $http_code == 200) {
                $responseAPI = $response;
            } else {
                echo 'Ressource introuvable : ' . $http_code;
            }
        } catch (Throwable $th) {
            throw $th;
        } finally {
            curl_close($ch);
        }

        return $responseAPI;
    }

    private function getDateLastUpdate()
    {
        $lastSave = (new CmsCaller())->getData($this->databaseSaveFildName);

        if ($lastSave) {
            return $lastSave;
        } else {
            $this->setDateLastUpdate();

            return $this->getDateUpdate();
        }
    }

    private function getDateUpdate()
    {
        return (int) date('His');
    }

    private function setDateLastUpdate()
    {
        (new CmsCaller())->saveData($this->databaseSaveFildName, $this->getDateUpdate());
    }

    private function runJob()
    {
        new CronExecution();
    }

    private function getDayUpdate()
    {
        $lastSave = (new CmsCaller())->getData($this->databaseSaveFildName . '_day');

        if ($lastSave) {
            return $lastSave;
        } else {
            (new CmsCaller())->saveData($this->databaseSaveFildName . '_day', $this->getCurrentDay());

            return $this->getCurrentDay();
        }
    }

    private function getCurrentDay()
    {
        return (int) date('j');
    }

    private function runJobDay()
    {
        new AutomatidationExecuting();
    }
}

class AutomatidationExecuting
{
    /**
     * AutomatidationExecuting constructor.
     */
    public function __construct()
    {
        $this->updateAutoJour();
    }

    private function updateAutoJour()
    {
        // Récuperation des automatisation
        // $automatisations = (new AutomatisationController())->getAutomatisations();
        $automatisations = AutomatisationManager::set(Wp_caller::getInstance())->get_automatisations();

        // Filtre des auto active et du mode produit populaire
        $automatisations = array_filter(
            $automatisations,
            function ($e) {
                return $e->isActive() && $e->getHookSell(); // Récuepration des autoa ctive et populaire
            }
        );

        try {
            $videos = (new VideoController())->getVideos();
        } catch (PrestaShopDatabaseException $e) {
            return;
        }

        foreach ($automatisations as $automatisation) {
            $nb_video_create = $automatisation->getNbProduit();
            $nb_jours = $automatisation->getNbJours();
            $stat_fini = implode("','", [2, 11]);

            // Récuperation des ids des produit dans les facture et leur nombre sur x derneir jours
            $ids = DB::getInstance()->executeS('SELECT `product_id`   FROM `' . _DB_PREFIX_ . '_order_detail` INNER JOIN `' . _DB_PREFIX_ . '_orders` ON `' . _DB_PREFIX_ . '_orders`.`id_order` = `' . _DB_PREFIX_ . '_order_detail`.`id_order` WHERE  DATEDIFF(`' . _DB_PREFIX_ . '_orders`.`date_upd`,CURRENT_TIMESTAMP) BETWEEN -' . $nb_jours . ' AND ' . $nb_jours . ' AND `' . _DB_PREFIX_ . "_orders`.`current_state` IN ( '" . $stat_fini . "' ) GROUP BY `product_id`  ORDER BY SUM(`product_quantity`) DESC LIMIT " . $nb_video_create);

            // dump('SELECT `product_id`   FROM `ps_order_detail` INNER JOIN `ps_orders` ON `ps_orders`.`id_order` = `ps_order_detail`.`id_order` WHERE  DATEDIFF(`ps_orders`.`date_upd`,CURRENT_TIMESTAMP) BETWEEN -' . $nb_jours . ' AND ' . $nb_jours . " AND `ps_orders`.`current_state` IN ( '" . $stat_fini . "' ) GROUP BY `product_id`  ORDER BY SUM(`product_quantity`) DESC LIMIT " . $nb_video_create);

            if ($ids) {
                $ids = array_map(function ($e) {
                    return $e['product_id'];
                }, $ids); // Récupération final des ids

                dump($ids);

                foreach ($ids as $id) {
                    // On cherche si la video existe deja
                    $video = false;
                    foreach ($videos as $videoExist) {
                        if ($videoExist->getGabarit() == (new GabaritController())->getGabarit($automatisation->getGabarit())
                            && $videoExist->getProductId() == $id) {
                            $video = $videoExist;

                            break;
                        }
                    }

                    // Sinon on la créer
                    if (!$video) {
                        $video = $this->CreateVideo($id, $automatisation);

                        if (!$video) {
                            echo '<br> erreur de création de la video id : ' . $id . '<br>';

                            break;
                        } else {
                            echo '<br> video créer <br>';
                            $automatisation->setCreated($automatisation->getCreated() + 1);
                            (new AutomatisationController())->updateAutomatisation($automatisation);
                        }
                    } else {
                        echo '<br> video existe deja <br>';
                    }

                    dump($video);

                    // on ajoute la video a la playlist
                    $playlist = (new PlaylistController())->getPlaylist($automatisation->getPlaylist());

                    dump($automatisation->getPlaylist());

                    $playlist->addVideoBefore($video);

                    try {
                        (new PlaylistController())->updatePlaylist($playlist);
                    } catch (Matrix\Exception $e) {
                        PrestaShopLogger::addLog('Update playlist impossible , ' . $e->getMessage(), 3);
                    }
                }
            }
        }
    }

    private function runJob()
    {
        // $automatisations = (new AutomatisationController())->getAutomatisations();
        $automatisations = AutomatisationManager::set(Wp_caller::getInstance())->get_automatisations();

        foreach ($automatisations as $automatisation) {
            if ($automatisation->isActive() && $automatisation->getHookSell()) {
                // recuperation des ids des x dernieres commande suivant le nombre de jours a selectionner
                $maxDate = date('y-m-d H:i:s', strtotime('-' . $automatisation->getNbJours() . ' days'));
                $orders = Db::getInstance()->executeS('SELECT `id_order` FROM `' . _DB_PREFIX_ . 'orders` WHERE `current_state` = 2 AND `invoice_date` >= "' . $maxDate . '"');
                $orders = array_map(
                    function ($order) {
                        return $order['id_order'];
                    },
                    $orders
                );

                // recuperation des produit de ces commandes
                $product = [];
                $orders_product_ids = Db::getInstance()->executeS('SELECT `product_id` , `product_quantity`  FROM `' . _DB_PREFIX_ . 'order_detail` WHERE `id_order` IN (' . implode(',', $orders) . ')');

                if (count($orders_product_ids) > 0) {
                    // assemblage de toutes les commande
                    $orders_product_ids_assemble = [];

                    foreach ($orders_product_ids as $order_product_id) {
                        if (isset($orders_product_ids_assemble[$order_product_id['product_id']])) {
                            $orders_product_ids_assemble[$order_product_id['product_id']] = (int) $orders_product_ids_assemble[$order_product_id['product_id']] + (int) $order_product_id['product_quantity'];
                        } else {
                            $orders_product_ids_assemble[$order_product_id['product_id']] = (int) $order_product_id['product_quantity'];
                        }
                    }

                    dump($orders_product_ids_assemble);

                    $articelMostSellByIds = $this->getCproduct($orders_product_ids_assemble);

                    // filtre le nombre de cideo a créer
                    $articelMostSellByIds = array_slice($articelMostSellByIds, 0, (int) $automatisation->getNbProduit());

                    $videosCompte = (new VideoController())->getVideos();

                    foreach ($articelMostSellByIds as $idProductVideoCreateAuto) {
                        $videoNeedToBeCreated = true;

                        // cherche si la video existe deja et si oui, l'ajout dans la playlist sans la créer
                        foreach ($videosCompte as $videoCompte) {
                            if ((int) $videoCompte->getProductId() == (int) $idProductVideoCreateAuto && (int) $videoCompte->getGabarit()->getId() == (int) $automatisation->getGabarit()) {
                                $playList = (new PlaylistController())->getPlaylist($automatisation->getPlaylist());
                                $playList->addVideoBefore($videoCompte->getIdDemande());
                                (new PlaylistController())->updatePlaylist($playList);

                                $videoNeedToBeCreated = false;

                                break;
                            }
                        }

                        if ($videoNeedToBeCreated) {
                            $this->CreateVideo($idProductVideoCreateAuto, $automatisation);
                        }
                    }
                }
            }
        }
    }

    public function getCproduct($orders_product_ids_assemble)
    {
        $liste = [];

        while (count($orders_product_ids_assemble) > 0) {
            $max = 0;

            foreach ($orders_product_ids_assemble as $productUd => $quantity) {
                if ($quantity > $max) {
                    $max = $quantity;
                }
            }

            foreach ($orders_product_ids_assemble as $productUd => $quantity) {
                if ($quantity == $max) {
                    $liste[] = $productUd;
                    unset($orders_product_ids_assemble[$productUd]);
                }
            }
        }

        return $liste;
    }

    private function CreateVideo($idProductVideoCreateAuto, $automatisation)
    {
        $product = new Product($idProductVideoCreateAuto);
        $video = new VideoEntity();
        $gabaritC = new GabaritController();

        $gabarit = $gabaritC->getGabarit((int) $automatisation->getGabarit());

        $datas = [];
        $imageCompteur = 1;
        $images = $this->getImages($idProductVideoCreateAuto);

        foreach ($gabarit->getChamps() as $champ) {
            $p = get_object_vars($product);

            if ($champ['name'] == 'image_' . $imageCompteur) {
                if (isset($images[$imageCompteur - 1])) {
                    $datas[$champ['name']] = $images[$imageCompteur - 1]['path'];
                } else {
                    $datas[$champ['name']] = $images[0];
                }

                $imageCompteur = $imageCompteur + 1;
            } else {
                $value = $this->implodeAll(' ', (isset($p[$champ['prestahsop_champ_name']])) ? $p[$champ['prestahsop_champ_name']] : $champ['default']);
                $value = strip_tags($value);

                if (empty($value)) {
                    $value = '.';
                }

                $datas[$champ['name']] = $this->implodeAll(' ', $value);
            }
        }

        if (isset($datas['produit_prix_euro'])) {
            $prix = $datas['produit_prix_euro'];

            if (!empty($datas['produit_prix_euro'])) {
                $datas['produit_prix_euro'] = floor($prix);
            }

            if (isset($datas['produit_prix_centime'])) {
                if (empty($datas['produit_prix_centime'])) {
                    $datas['produit_prix_centime'] = ($prix - floor($prix)) * 10;
                }
            }
        }

        if (isset($datas['produit_description'])) {
            $datas['produit_description'] = addslashes($datas['produit_description']);
        }

        $datas['product_id'] = $product->id;

        $video->setData($datas);
        $video->setGabarit($gabarit->getId());
        $video->setDateBegin(date('Y-m-d H:i:s'));
        $video->setDateEnd(date('Y-m-d H:i:s'));
        $video->setVideoComment('');
        $video->setVideoName($this->implodeAll(' ', $product->name));
        $video->setAutomatique('0');
        $video->setProductId($product->id);
        $video->setDateDemande(date('Y-m-d H:i:s'));
        $video->setAutomatique(true);
        $video->setListeIdBoxes(';;');
        $video->setIdCompte(UserController::getInstance()->getCurrentUser()->getIdCompte());
        $video->setAEVersion($gabarit->getAEVersion());

        $videoC = new VideoController();

        // poste la création de video
        return $videoC->postVideo($video);
    }

    public function getImages($id_product)
    {
        // Tous les lien vers les images
        $all_links = [];

        // Initialize the link object
        $link = new Link();

        // Récuperation du protocole
        $protocol = (isset($_SERVER['HTTPS'])) ? ($_SERVER['HTTPS'] && $_SERVER['HTTPS'] != 'off') ? 'https' : 'http' : 'http';

        // Language id
        $id_lang = (int) Configuration::get('PS_LANG_DEFAULT');

        // Load Product Object
        $product = new Product($id_product);

        // Validate CMS Page object
        if (Validate::isLoadedObject($product)) {
            // Get product images
            $productImages = $product->getImages((int) $id_lang);

            if ($productImages && count($productImages) > 0) {
                foreach ($productImages as $key => $val) {
                    // Récuperation de l'id du produit
                    $id_image = $val['id_image'];

                    // Convertion et ajout au images depuis l'id d'une image en son chemin relatif
                    $all_links[] = [
                        'url' => $protocol . '://' . $link->getImageLink($product->link_rewrite[Context::getContext()->language->id], $id_image, ImageType::getFormattedName('home')),
                        'path' => _PS_PROD_IMG_DIR_ . implode('/', str_split($id_image)) . '/' . $id_image . '.jpg',
                    ];
                }
            }
        }

        return $all_links;
    }

    private function implodeAll($delimiteur, $array)
    {
        if (is_array($array)) {
            return implode($delimiteur, $array);
        }

        return $array;
    }
}

class CronExecution
{
    private $videoC;

    // Point d'entrer pour cette classe
    public function __construct()
    {
        $this->videoC = new VideoController();
        $this->runJob();
    }

    private function runJob()
    {
        $idsVideosNotDone = $this->getIdsVideosNotDone();
        $this->getNewVideos($idsVideosNotDone);
    }

    /**
     * recuperation des ids des videos local qui ne sont pas fini
     *
     * @return null[]|string[]
     */
    private function getIdsVideosNotDone()
    {
        try {
            // Maps la recupération des ids sur les videos qui non pas le flag completed
            return array_map(
                function ($video) {
                    return $video->getIdDemande();
                },
                $this->videoC->getVideos(
                    [
                        'flag !' => 'completed',
                    ]
                )
            );
        } catch (PrestaShopDatabaseException $e) {
            exit('error : ' . $e->getMessage());
        }
    }

    private function getNewVideos($idsVideosNotDone)
    {
        $remotesVideos = array_map(
            function ($idVideo) {
                return $this->videoC->getRemoteVideo($idVideo);
            },
            $idsVideosNotDone
        );

        foreach ($remotesVideos as $remoteVideo) {
            if ($remoteVideo) {
                switch ($remoteVideo->getFlag()) {
                    case 'in_progress':
                    case 'error':
                        $this->videoC->updateLocalVideo($remoteVideo);

                        break;

                    case 'completed':
                        $urlRemoteVideo = $remoteVideo->getVideoUrl();
                        $hashRemoteVideo = $remoteVideo->getVideoHash();

                        // Tentative de telechargeemnt de la video
                        $file_name = basename($urlRemoteVideo);

                        $filePath = '../../videos/' . $remoteVideo->getIdDemande();

                        mkdir($filePath, 0777);
                        chmod($filePath, 0777);

                        $sameHash = false;
                        $maxCompteur = 10;

                        while (!$sameHash || $maxCompteur > 0) {
                            if (file_put_contents($filePath . '/' . $file_name, Tools::file_get_contents($urlRemoteVideo))) {
                                chmod($filePath . '/' . $file_name, 0777);
                                if (hash_file('md5', $filePath . '/' . $file_name) == $hashRemoteVideo) {
                                    if (file_put_contents($filePath . '/' . str_replace('mp4', 'ogv', $file_name), Tools::file_get_contents(str_replace('.mp4', '.ogv', $urlRemoteVideo)))) {
                                        chmod($filePath . '/' . str_replace('mp4', 'ogv', $file_name), 0777);
                                        $sameHash = true;
                                        $this->uploadVideoYoutube($urlRemoteVideo);
                                    }
                                }

                                $this->videoC->updateLocalVideo($remoteVideo);
                            } else {
                                echo 'File downloading failed.';
                            }

                            $maxCompteur = $maxCompteur - 1;
                        }

                        break;

                    default:
                        // Do nothing if the video don't have a updatable statut ( exemple waiting )
                        break;
                }
            }
        }
    }
}
