<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
if (file_exists('./../../../../wp-load.php')) {
    define('WP_USE_THEMES', false); // Don't load theme support functionality
    require './../../../../wp-load.php';
} else {
    require './../../../../config/config.inc.php';
    require './../../../../init.php';
    require_once './../../digitalsignage.php';
}

require_once './CreationVideoSpecialDataProvider.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

if (Tools::getIsset('digitalSignageSpecialData')) {
    if (isset($_GET['ia_question'])) {
        $datasProvider = new CreationVideoSpecialDataProvider();
        $retour = $datasProvider->IA_description($_GET['ia_question'], $_GET['id_product']);
        ob_get_clean();
        echo $retour;
    } else {
        $handler = new CreationVideoSpecialDataProviderAjaxHandler($_GET['digitalSignageSpecialData']);
        $handler->display();
    }
}

class CreationVideoSpecialDataProviderAjaxHandler
{
    public $data = '';

    public function __construct($request)
    {
        $datasProvider = new CreationVideoSpecialDataProvider();
        /*
        switch ($request) {

            case "siteUrl" :
                $this->data = $datasProvider->siteUrl();
                break;

            case "siteName" :
                $this->data = $datasProvider->siteName();
                break;

            case "siteLogo" :
                $this->data = $datasProvider->siteLogo();
                break;

            case "watermarkPicture" :
                $this->data = $datasProvider->watermarkPicture();
                break;

            case "watermarkPlacement" :
                $this->data = $datasProvider->watermarkPlacement();
                break;

            case "devise" :
                $this->data = $datasProvider->devise();
                break;

            case "currency" :
                $this->data = $datasProvider->currency();
                break;

            case "priceCurrencyAlign" :
                $this->data = $datasProvider->priceCurrencyAlign();
                break;

            case "priceCentValign" :
                $this->data = $datasProvider->priceCentValign();
                break;

            case "priceDecimalSeparator" :
                $this->data = $datasProvider->priceDecimalSeparator();
                break;

            case "priceThousandSeparator" :
                $this->data = " ";
                break;

            case "videoWidth" :
                $this->data = $datasProvider->videoWidth();
                break;

            case "videoHeight" :
                $this->data = $datasProvider->videoHeight();
                break;
            default  :

               $this->data=$request;
               break;
        }
        */

        $callableFunctionData = [$datasProvider, $request];
        if (is_callable($callableFunctionData)) {
            $this->data = call_user_func($callableFunctionData);
        } else {
            $this->data = $request;
        }
    }

    public function display()
    {
        ob_get_clean();
        echo $this->data;
        exit;
    }
}
