<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
require_once 'Entity.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

class GabaritEntity extends Entity
{
    private $id;

    private $nom;

    private $lien_video_exemple;

    private $champs;

    private $AE_version;

    private $actif;

    private $isUsable;

    private $textAdd;

    private $orientation = 1;

    private $champs_custom;

    private $iamodelequestion;

    /**
     * GabaritEntity constructor.
     */
    public function __construct()
    {
    }

    /**
     * @return null
     */
    public function getIsUsable()
    {
        return $this->isUsable;
    }

    /**
     * @param null $isUsable
     */
    public function setIsUsable($isUsable)
    {
        $this->isUsable = $isUsable;
    }

    public function setCustom($champs_custom)
    {
        $this->champs_custom = $champs_custom;
        // Retrait du Limit 1 car "erreur de syntaxe"
        $sql = 'SELECT * FROM ' . Db::getInstance()->getPrefix() . 'digitalsignage_gabarit WHERE id_gabarit = ' . (int) $this->id;
        $resultat = Db::getInstance()->getRow($sql);
        if ($resultat != null) {
            $sql = 'DELETE FROM ' . Db::getInstance()->getPrefix() . "digitalsignage_gabarit WHERE id_gabarit='" . (int) $this->id . "' LIMIT 1;";
            Db::getInstance()->execute($sql);
        }
        Db::getInstance()->insert('digitalsignage_gabarit', ['parameters' => json_encode($this->champs_custom), 'id_gabarit' => (int) $this->id]);
        // var_dump(Db::getInstance()->getMsgError());die;
    }

    public function getCustom()
    {
        // todo Enlever le SQL de là
        // creer la table des gabarits si elle n'existe pas
        $this->champs_custom = [];
        $sql = 'CREATE TABLE IF NOT EXISTS ' . Db::getInstance()->getPrefix() . "digitalsignage_gabarit ( 
					`id` INT(11) NOT NULL AUTO_INCREMENT , 
					`id_gabarit` INT(11) NOT NULL,
					`parameters` text NOT NULL DEFAULT '',
					PRIMARY KEY (`id`), 
					INDEX (`id_gabarit`))";
        Db::getInstance()->execute($sql);

        // chercher si il y a une personnalisation
        $sql = 'SELECT * FROM ' . Db::getInstance()->getPrefix() . 'digitalsignage_gabarit WHERE id_gabarit = ' . (int) $this->id;
        $resultat = Db::getInstance()->getRow($sql);
        if ($resultat != null) {
            $this->champs_custom = json_decode($resultat['parameters'], true);
        }

        return $this->champs_custom;
    }

    public function initCustomChamp()
    {
        $customisation = $this->getCustom();
        if (count($customisation) > 0) {
            // file_put_contents('debug_ag.txt',"customisation:"."\n",FILE_APPEND);
            // file_put_contents('debug_ag.txt',serialize($customisation)."\n",FILE_APPEND);

            $champs_retour = [];
            $champs_gabarit = $this->getChamps();
            // file_put_contents('debug_ag.txt',"champs_gabarit:"."\n",FILE_APPEND);
            // file_put_contents('debug_ag.txt',serialize($champs_gabarit),FILE_APPEND);
            foreach ($champs_gabarit as $champs_) {
                // siteUrl
                // file_put_contents('debug_ag.txt',"champs".$champs_['prestahsop_champ_name']."\n",FILE_APPEND);
                // $champs_['prestahsop_champ_name']="";
                // $champs_['wordpress_champ_name']="";
                // $champs_['default']="plop";
                if (array_key_exists($champs_['name'], $customisation)) {
                    $champs_['prestahsop_champ_name'] = $customisation[$champs_['name']];
                    $champs_['wordpress_champ_name'] = $customisation[$champs_['name']];
                    $champs_['default'] = $customisation[$champs_['name']];
                    if (array_key_exists($champs_['name'] . '_ia_question', $customisation)) {
                        $champs_['ia_question'] = $customisation[$champs_['name'] . '_ia_question'];
                    }

                    $champs_retour[] = $champs_;
                } else {
                    $champs_retour[] = $champs_;
                }
            }
            $this->setChamps($champs_retour);
        }

        return $this->champs;
    }

    /**
     * @return null
     */
    public function getIamodelequestion()
    {
        return $this->iamodelequestion;
    }

    /**
     * @param null $ia_modele_question
     */
    public function setIamodelequestion($iamodelequestion)
    {
        $this->iamodelequestion = $iamodelequestion;
    }

    /**
     * @return null
     */
    public function getTextAdd()
    {
        return $this->textAdd;
    }

    /**
     * @param null $textAdd
     */
    public function setTextAdd($textAdd)
    {
        $this->textAdd = $textAdd;
    }

    /**
     * @return null
     */
    public function getActif()
    {
        return $this->actif;
    }

    /**
     * @param null $actif
     */
    public function setActif($actif)
    {
        $this->actif = $actif;
    }

    /**
     * @return null
     */
    public function getId()
    {
        return $this->id;
    }

    /**
     * @param null $id
     */
    public function setId($id)
    {
        $this->id = $id;
    }

    /**
     * @return null
     */
    public function getNom()
    {
        return $this->nom;
    }

    /**
     * @param null $nom
     */
    public function setNom($nom)
    {
        $this->nom = $nom;
    }

    /**
     * @return null
     */
    public function getLienVideoExemple()
    {
        return $this->lien_video_exemple;
    }

    /**
     * @param null $lien_video_exemple
     */
    public function setLienVideoExemple($lien_video_exemple)
    {
        $this->lien_video_exemple = $lien_video_exemple;
    }

    /**
     * @return null
     */
    public function getChamps()
    {
        // file_put_contents('debug_ag.txt',"champs_gabarit:"."\n",FILE_APPEND);
        // file_put_contents('debug_ag.txt',serialize($this->champs),FILE_APPEND);
        return $this->champs;
    }

    /**
     * @param null $champs
     */
    public function setChamps($champs)
    {
        $this->champs = $champs;
    }

    /**
     * @return null
     */
    public function getAEVersion()
    {
        return $this->AE_version;
    }

    /**
     * @param null $AE_version
     */
    public function setAEVersion($AE_version)
    {
        $this->AE_version = $AE_version;
    }

    /**
     * @return null
     */
    public function getOrientation()
    {
        return $this->orientation;
    }

    /**
     * @param null $AE_version
     */
    public function setOrientation($orientation)
    {
        $this->orientation = $orientation;
    }
}
