<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
if (!defined('_PS_VERSION_')) {
    exit;
}

interface CMS_Linker
{
    /**
     * function de sauvegarde des données dans le cms
     * Si le $name_data existe deja alors ecraser la valeur existante
     *
     * @param $name_data
     * @param $data
     *
     * @return bool
     */
    public function save_data($name_data, $data);

    /**
     * fonction de recuperation des données du cms
     * si la valeur existe pas, alors retourner false
     *
     * @param $name
     *
     * @return mixed
     */
    public function get_data($name);

    /**
     * fonction de suppression de la données
     *
     * @param $name
     *
     * @return bool
     */
    public function delete_data($name);

    /**
     * Fonction qui permet la création de la table video dans les cms
     *
     * @return mixed
     */
    public function create_video_table();

    /**
     * Execute une requete sql sur la table des videos
     *
     * @param $request
     *
     * @return mixed
     */
    public function execute_video_request($request);
}
