<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
require_once __DIR__ . '/../Classes/Tools_DS4.php';
require_once __DIR__ . '/../Kernel/Translations/DigitalSignageTranslate.php';
require_once __DIR__ . '/../Classes/Wp_caller.php';
require_once __DIR__ . '/../Kernel/API/Entity/DemandeEntity.php';
require_once __DIR__ . '/../Kernel/API/Entity/PlaylistEntity.php';
require_once __DIR__ . '/../Kernel/API/Manager/DemandeManager.php';
require_once __DIR__ . '/../Kernel/API/Manager/DigitalSignageException.php';
require_once __DIR__ . '/../Kernel/API/Manager/PlaylistManager.php';
require_once __DIR__ . '/../Kernel/API/Manager/GabaritManager.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

class GabaritController extends DigitalSignageController
{
    public function generatePage()
    {
        $this->route();
    }

    private function route()
    {
        if (Tools::getIsset('id_gabarit')) {
            $this->display_gabarit();
        } else {
            $this->display_gabarits();
        }
    }

    private function display_gabarit()
    {
    }

    private function display_gabarits()
    {
        $gabarits = GabaritManager::instance()->getGabarits();

        $clean_path = Tools_DS4::getModuleUrlPresta() . 'views/img/no.png';
        $clean_path = str_replace('\\', '/', $clean_path);

        $this->assign([
            'gabarits' => $gabarits,
            'urlSpecialData' => Tools_DS4::getModuleUrlPresta() . 'ds4woo/Classes/CreationVideoSpecialDataProviderAjaxHandler.php?digitalSignageSpecialData=',
            'urlTraitement' => Tools_DS4::getModuleUrlPresta() . 'ds4woo/controllers/override/AddGabaritCustomizeHandler.php',
            'urlLoadingImg' => Tools_DS4::getModuleImgDirPresta() . 'loadingChamp.gif',
            'urlnoImg' => Tools_DS4::getModuleUrlPresta() . 'views/img/no.png',
            'pathnoImg' => $clean_path,
            'logosite' => get_site_icon_url(),
            'urlChangeDisplayedVideo' => Tools_DS4::getModuleUrlPresta() . 'ds4woo/Classes/DisplayedVideoProductAjaxHandler.php',
        ]);

        $this->setWPTemplate('../hook/front/adminGabaritCustomizeForm');
    }
}
