<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
if (!defined('_PS_VERSION_')) {
    exit;
}

class UpdateVideoHandlerManager
{
    private $demande_item;

    private $demande_id;

    private $product_id;

    /**
     * @param bool $product_item
     * @param string $product_id
     * @param string $product_flag
     */
    public function __construct($demande_item, $demande_id, $product_id)
    {
        $this->demande_item = $demande_item;
        $this->demande_id = $demande_id;
        $this->product_id = $product_id;

        if (Tools_DS4::isPrestashop()) {
            refresh_local_token();
        }
    }

    public function getHtmlDatas()
    {
        return $this->load();
    }

    public function echoHtmlDatas()
    {
        exit($this->getHtmlDatas());
    }

    private function load()
    {
        $oldObBufferDatas = ob_get_clean();

        ob_start();

        // Aller chercher le forfait
        $forfait = ForfaitManager::instance()->getForfait(ForfaitManager::instance()->getToken(), true);

        if (isset($this->demande_id)) {
            $video = $this->getVideo($this->demande_id);

            if (!$video) {
                echo 'error';
            } elseif (isset($this->demande_item) && $this->demande_item == 'true') {
                ?>

                    <div style='width: 200px;margin-bottom: 10px;margin-right: 30px;background-color: rgba(62, 238, 32, 0.16);min-height: 190px;height: max-content;'>

                        <div style='margin:0; width: 100%;height: 170px' data-ds-flag='<?php echo $video->getFlag(); ?>'
                             data-ds-id='<?php echo $video->getIdDemande(); ?>'
                             id='video_ds_<?php echo $video->getIdDemande(); ?>'
                             class='creation_box video_dispo '>

                            <?php

                            if ($forfait->isExpired()) { ?>
									
									<div data-ds-flag="error"></div>
                                    <span class="info"><?php echo DigitalSignageTranslate::getTraduction('Expiree'); ?></span>
                                    <div class="lds-ellipsis error_video"></div>
                                    <span> <?php echo $video->getDateDemande(); ?>  </span>
									
                                <?php } elseif ($video->getFlag() == 'error') { ?>

                                    <div data-ds-flag="error"></div>
                                    <span class="info"><?php echo DigitalSignageTranslate::getTraduction('Erreur'); ?></span>
                                    <div class="lds-ellipsis error_video"></div>
                                    <span> <?php echo $video->getDateDemande(); ?>  </span>

                                <?php } elseif ($video->getFlag() == 'waiting') { ?>

                                    <div data-ds-flag="waiting"></div>
                                    <span class="info"><?php echo DigitalSignageTranslate::getTraduction('Attente_creation'); ?></span>
                                    <div class="sablier"></div>
                                    <span> <?php echo $video->getDateDemande(); ?>  </span>

                                <?php } elseif ($video->getFlag() == 'in_progress') { ?>

                                    <div data-ds-flag="in_progress"></div>
                                    <span class="info"><?php echo DigitalSignageTranslate::getTraduction('En_cours_creation'); ?></span>
                                    <div class="lds-ellipsis">
                                        <div></div>
                                        <div></div>
                                        <div></div>
                                        <div></div>
                                    </div>

                                    <span> <?php echo $video->getDateDemande(); ?>  </span>

                                <?php } elseif ($video->getFlag() == 'completed') { ?>

                                    <div data-ds-flag="completed"></div>
                                    <span> <?php echo $video->getVideoName(); ?> </span>
                                    <div class="video">

                                        <video controls width="200" height="114" preload="metadata" muted="muted">

                                            <source src="<?php echo $video->getVideoUrl(); ?>"
                                                    type="video/mp4">

                                            <!--source src="<?php echo $video->getVideoUrlOgv(); ?>"
                                                    type="video/ogv"-->

                                        </video>

                                    </div>

                                    <span> <?php echo $video->getDateDemande(); ?>  </span>

                                    <?php

                                try {
                                    $check = (DisplayedVideoProduct::getDisplayedVideoProduct($this->product_id) == $video->getIdDemande()) ? "checked='checked'" : '';
                                } catch (Exception $e) {
                                    $check = '';
                                }

                                    ?>

                                    <input onclick="updateDisplayedVideo( <?php echo $this->demande_id; ?>, <?php echo $this->product_id; ?> )"
                                           type="radio" name="displayOnFront" <?php echo $check; ?> />


                                <?php } ?>

                        </div>
                    </div>


                <?php } else { ?>

                    <div class="row row_ds4" id="row_<?php echo $video->getIdDemande(); ?>"
                         data-id="<?php echo $video->getIdDemande(); ?>"
                         data-flag="<?php echo $video->getFlag(); ?>">

                        <!--div class="cell" data-title="" style="width: calc(80px + 5em);"-->
                        <div class="cell" data-title="">

                            <?php if ($video->getFlag() == 'completed') { ?>
                                <button style="padding: .55em; border-radius: 2em; background-color: #e07281; border: none; margin-left: 1em !important;"
                                        onclick="saveIdDeletePlaylist(<?php echo $video->getIdDemande(); ?>)"
                                        class="btn btn_ds btn-primary"
                                        data-toggle="modal" data-target="#ModalV">
                                    <span class="material-icons">  delete  </span>
                                </button>
                            <?php } ?>


                        </div>



                        <div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Aperçu'); ?>">

                            <?php if ($video->getFlag() == 'completed') { ?>

                                <div style="margin-left:10px">
                                    <span onclick="toggleVideo(this)" style="padding: 5px;"
                                          class="click  material-icons">play_circle_outline</span>
                                    <span onclick="toggleVideo(this , true)"
                                          style=" border-bottom-right-radius: 18px;border-top-left-radius: 18px;border-bottom-left-radius: 18px;padding: 5px;background: grey;color: whitesmoke"
                                          class="click  material-icons display_none">highlight_off</span>
                                </div>

                                <div class="video">
                                    <video controls loop=""
                                           style="background: white; padding:10px;position: absolute;border:2px solid grey ; margin: -34px 41px;"
                                           class="display_none" preload="none" muted="muted" width="300">
                                        <source src="<?php echo $video->getVideoUrlOgv(); ?>"
                                                type="video/ogg">
                                        <source src="<?php echo $video->getVideoUrl(); ?>"
                                                type="video/mp4">
                                    </video>
                                </div>

                            <?php } ?>

                        </div>

                        <!--div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Nom'); ?>">
                            <?php echo $video->getVideoName(); ?>
                        </div-->

                        <div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Produit'); ?>">
                            <?php echo $video->getProductId(); ?>
                        </div>

                        <div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Id'); ?>"><!-- ShortCode -->

                            <?php

                                if ($video->getFlag() == 'error') {
                                    echo DigitalSignageTranslate::getTraduction('Erreur');
                                } elseif ($video->getFlag() == 'waiting') {
                                    echo DigitalSignageTranslate::getTraduction('Pas_encore_dispo');
                                } elseif ($video->getFlag() == 'in_progress') {
                                    echo DigitalSignageTranslate::getTraduction('Pas_encore_dispo');
                                } elseif ($video->getFlag() == 'noSpace') {
                                    echo DigitalSignageTranslate::getTraduction('Secu_disque_bloque_telechargement_video');
                                } elseif ($video->getFlag() == 'completed') {
                                    echo '[digitalsignage4 id=' . $video->getIdDemande() . ']';
                                }

                    ?>

                        </div>
                        
                        <div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Statut'); ?>">

                            <?php

                        if ($forfait->isExpired()) {
                            echo DigitalSignageTranslate::getTraduction('Expiree');
                        } elseif (substr($video->getFlag(), 0, 5) == 'error') {
                            if (substr($video->getFlag(), 0, 6) == 'error;') {
                                $errormsg = explode(';', $video->getFlag());
                                $msgs = $errormsg[1];
                                echo DigitalSignageTranslate::getTraduction('Erreur');
                                echo $msgs;
                            } else {
                                echo DigitalSignageTranslate::getTraduction('Erreur');
                            }
                        } elseif ($video->getFlag() == 'waiting') {
                            echo DigitalSignageTranslate::getTraduction('Attente');
                        } elseif ($video->getFlag() == 'noSpace') {
                            echo DigitalSignageTranslate::getTraduction('Bloquee');
                        } elseif ($video->getFlag() == 'in_progress') {
                            echo DigitalSignageTranslate::getTraduction('En_cours_creation');
                        } elseif ($video->getFlag() == 'completed') {
                            echo DigitalSignageTranslate::getTraduction('Creee');
                        }

                    ?>

                        </div>


                        <div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Gabarit'); ?>">

                            <?php if ($video->getGabarit()) { ?>

                                <div style="display: flex;align-items: center;width: 100%;height: 100%">
                                    <?php echo $video->getGabarit()->getNom(); ?>
                                    <div style="opacity: .5">
                                    <span onclick="toggleVideo(this)" style="padding: 5px;"
                                          class="click  material-icons">play_circle_outline</span>
                                        <span onclick="toggleVideo(this , true)"
                                              style=" border-bottom-right-radius: 18px;border-top-left-radius: 18px;border-bottom-left-radius: 18px;padding: 5px;background: grey;color: whitesmoke"
                                              class="click material-icons display_none">highlight_off</span>
                                    </div>
                                    <div class="video">
                                        <video controls loop
                                               style="background: white; padding:10px;position: absolute;border:2px solid grey ; margin: -17px 0;"
                                               width="300" class="display_none" preload="none" muted="muted">
                                            <source src="<?php echo $video->getGabarit()->getLienVideoExemple(); ?>"
                                                    type="video/mp4">
                                        </video>
                                    </div>
                                </div>

                            <?php } else { ?>
                                <?php echo DigitalSignageTranslate::getTraduction('gabarit_introuvable'); ?>
                            <?php } ?>

                        </div>

                        <div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Automatique'); ?>">

                            <?php echo strtoupper(
                                ($video->getAutomatique())
                                            ? DigitalSignageTranslate::getTraduction('Oui')
                                            : DigitalSignageTranslate::getTraduction('Non')
                            ); ?>

                        </div>

                        <div class="cell" data-title="<?php echo DigitalSignageTranslate::getTraduction('Date_demande'); ?>">
                            <?php echo $video->getDateDemande(); ?>
                        </div>

                        <div style="text-align: center;" class="cell"
                             data-title="<?php echo DigitalSignageTranslate::getTraduction('Download_video'); ?>">
							<?php

                                        if ($forfait->getCanDownload()) {
                                            ?>
                            <?php if ($video->getFlag() == 'completed') { ?>
                                <a href="<?php echo $video->getVideoUrl(); ?>"
                                   download="<?php echo mb_strtolower(str_replace(' ', '_', $video->getVideoName())); ?>">
								   <!--span class="click  material-icons">file_download</span-->
									<img src="<?php echo Tools_DS4::getModuleUrlPresta() . 'views/img/download-ok.png'; ?>"/>
								</a>
                            <?php } ?>
							<?php } else { ?>
								
									<div class="ds4_popup" onclick="showHideDS4Popup(<?php echo $video->getIdDemande(); ?>)">
										<img src="<?php echo Tools_DS4::getModuleUrlPresta() . 'views/img/download-ko.png'; ?>"/>
										<span class="ds4_popuptext" id="myPopup<?php echo $video->getIdDemande(); ?>"><?php echo DigitalSignageTranslate::getTraduction('Download_ko', Tools_DS4::getAcaciaRedirectionPageUrl('getdownload')); ?></span>
									</div>
								
							<?php } ?>
                        </div>

                    </div>


                    <?php

                }
        }
        ?>
			
			<?php

        $resultHtml = ob_get_clean();
        ob_start();
        echo $oldObBufferDatas;

        return $resultHtml;
    }

    private function getVideo($demande_id)
    {
        $video = DemandeManager::set(Wp_caller::getInstance())->getLocalDemandes('SELECT * FROM %s WHERE `id_demande` = ' . $demande_id);

        if ($video) {
            $video = Tools_DS4::convertPoductIdToLink($video);
            $video = $video[0];

            return $video;
        }

        return false;
    }
}
