<?php
/**
 * @author Acacia Dynamic
 * @copyright 2024 Acacia Dynamic
 * @license private
 */
require_once _PS_ROOT_DIR_ . '/modules/digitalsignage/digitalsignage.php';

if (!defined('_PS_VERSION_')) {
    exit;
}

class ProductController extends ProductControllerCore
{
    private $params = [];

    private $idVideo = -1;

    public function initContent()
    {
        // Récuperation de l'id de la video
        $this->idVideo = $this->getIdVideo();

        // Recuperation des parametres
        $this->params = $this->getParamets();

        // Override des element pour placer les videos
        $this->product->description_short = $this->addBeforeShortDescripiton($this->product->description_short);
        $this->product->description_short = $this->addAfterShortDescripiton($this->product->description_short);
        $this->product->description = $this->addBeforeDescripiton($this->product->description);
        $this->product->description = $this->addAfterDescripiton($this->product->description);

        //            // Ajout de js pour les emplaceent 5 et 6 apres description car description_short est appelé plusieurs fois
        $this->product->description = $this->addJsForOtherVideosPlacement($this->product->description);

        parent::initContent();
    }

    /**
     * @return int
     */
    private function getIdVideo()
    {
        $idVideo = -1;

        $caller = new Wp_caller();
        $datas = $caller->execute_video_request("select * from %s WHERE `flag` = 'completed' AND `product_id` = " . $this->product->id . ' ORDER BY `id_demande` DESC LIMIT 1 ');
        if ($datas && !empty($datas)) {
            $idVideo = $datas[0]['id_demande'];
        }

        return $idVideo;
    }

    private function getParamets()
    {
        $params = Wp_caller::getInstance()->get_data(Wp_caller::PLACEMENT);
        if (!is_array($params)) {
            $params = [$params];
        }

        return $params;
    }

    private function addBeforeShortDescripiton($description_short)
    {
        if (isset($this->params['placement_1'])) {
            return " <span style='color:transparent'> [digitalsignage4 id=" . $this->idVideo . '] </span> ' . $description_short;
        }

        return $description_short;
    }

    private function addAfterShortDescripiton($description_short)
    {
        if (isset($this->params['placement_2'])) {
            return $description_short . " <span style='color:transparent'> [digitalsignage4 id=" . $this->idVideo . '] </span> ';
        }

        return $description_short;
    }

    private function addBeforeDescripiton($description)
    {
        if (isset($this->params['placement_3'])) {
            return " <span style='color:transparent'> [digitalsignage4 id=" . $this->idVideo . '] </span> ' . $description;
        }

        return $description;
    }

    private function addAfterDescripiton($description)
    {
        if (isset($this->params['placement_4'])) {
            return $description . "<span style='color:transparent'> [digitalsignage4 id=" . $this->idVideo . '] </span>';
        }

        return $description;
    }

    private function addJsForOtherVideosPlacement($description_short)
    {
        $user_connected = false;

        // si l'uilisateur n'est pas connecté on stop
        if (!ForfaitManager::instance()->getToken()) {
            $user_connected = new ForfaitEntity();
            $success = $user_connected->fromArray(Wp_caller::getInstance()->get_data(Wp_caller::FORFAIT));

            if ($success) {
                ForfaitManager::instance()->setForfait($user_connected);
            } else {
                return false;
            }
        }

        // Si la video de ce produit existe pas, on stop
        if ($this->idVideo == -1) {
            return false;
        }

        $video_url_dir = Tools_DS4::getModuleVideoUrl();

        $js = '';
        ob_start();

        ?>
            <script>
console.log('placement56 ok');
                if ("<?php echo isset($this->params['placement_5']); ?>" === "1") {

                    let div = document.createElement('div');
                    let p = document.createElement('p');
                    p.innerHTML = ` <span style='color:transparent'> [digitalsignage4 id=<?php echo $this->idVideo; ?>] </span> `;
                    div.appendChild(p);
                    
                    document.getElementById('content').after(div);
                }

                if ("<?php echo isset($this->params['placement_6']); ?>" === "1") {

                    let images_cont = document.getElementsByClassName('js-qv-product-images');

                    let element = images_cont[0];

                    let li = document.createElement('li');
                    li.classList.add("thumb-container");


                    let div = document.createElement('div');
                    div.style.verticalAlign = "middle";
                    div.style.display = "inline-grid";
                    div.style.height = "100px";
                    div.style.width = "100px";
                    div.style.background = "black";
                    div.classList.add("thumb", "js-thumb");
                    div.setAttribute('width', '100');
                    div.setAttribute('title', 'digital signage 4 video');


                    let p = document.createElement('p');

                    p.style.display = "flex";
                    p.innerHTML = ` <span style='color:transparent'> [digitalsignage4 id=<?php echo $this->idVideo; ?>] </span> `;
                    p.style.margin = "0";
                    p.classList.add("video_container");
                    p.classList.add('gg-play-button');

                    div.appendChild(p);
                    li.appendChild(div);

                    element.insertBefore(li, element.firstChild);

                }

                let videoFileStorageUrl = "<?php echo $video_url_dir; ?>";
                let videoExistent = [];

                addCustomProductPictureStyle();

                /**
                 * Cherche els shortcodes apres le chargement de la page, sinon le body est encore vide
                 */
                // Convertion des shortcodes

                // document.body.innerHTML = findAndReplaceShortCode(document.body.innerHTML);

                addVideoToproductPicture();

                /**
                 * Cherche et remplace les shortcode via la function shortCodeCovertion
                 * @param text
                 * @returns string
                 */
                function findAndReplaceShortCode(text) {

                    console.log(text);

                    // Séparation du body sur le shortcode
                    let bodySlite = text.split('[digitalsignage4 id=');

                    console.log(bodySlite);

                    // Boucle sur tous les shortcode possible sur la page
                    for (var item in bodySlite) {

                        // Récuperation du block
                        let block = bodySlite[item];

                        // Récuperation de l'id du shortcode
                        let blockSplit = block.split("]");
                        let possibleNumber = blockSplit[0];

                        // Test si cette id existe
                        let videoId = null;
                        if (!isNaN(possibleNumber)) {
                            videoId = parseInt(possibleNumber);
                        }

                        // Convertion du shortcode via la function shortCodeCovertion
                        if (videoId) {

                            console.log(videoId);

                            // blockSplit[0] = shortCodeCovertion(videoId);
                            bodySlite[item] = blockSplit.join("")
                        }

                    }

                    // Renvois de l'input modifié
                    return bodySlite.join("");


                }

                /**
                 * Certion d'un id en une video visionnable en front
                 */
                function shortCodeCovertion(videoId) {

                    <?php if ($user_connected) { ?>

                    if (videoId) {

                        //création de la video
                        let video = getVideos(videoId);

                        if (video) {

                            //ajout du onclick pour les video dans les images

                            return video.outerHTML;

                        } else {
                            console.log('video introuvable');
                        }
                    }

                    <?php } ?>

                    return "";
                }


                /**
                 * Cherche si la video de cet id existe
                 * @returns boolean
                 * @param url
                 */
                function videoExiste(url) {

                    if (videoExistent.includes(url)) {
                        return true;
                    } else {

                        try {
                            var http = new XMLHttpRequest();
                            http.open('HEAD', url, false);
                            http.send();

                            if (http.status !== 404) {
                                videoExistent.push(url);
                                return true;
                            }

                            return false;

                        } catch (ex) {
                            console.log(error);
                            return false;
                        }

                    }

                }

                /**
                 * Création de la video en element dom
                 */
                function getVideos(videoId) {

                    let baseUrb = videoFileStorageUrl + videoId + "/" + videoId;

                    let mp4 = baseUrb + ".mp4";
                    let ogv = baseUrb + ".ogv";

                    if (videoExiste(mp4) && videoExiste(ogv)) {

                        let video = document.createElement('video');
                        video.style.width = "100%";
                        video.classList.add('ds4_video');

                        // Ajout des sources avec check de compatibilitée
                        if (video.canPlayType('video/mp4; codecs="avc1.42E01E,mp4a.40.2"')) {
                            let source = document.createElement("source");
                            source.type = "video/mp4";
                            source.src = mp4;
                            video.appendChild(source);
                        }

                        if (video.canPlayType('video/ogg; codecs="theora,vorbis"')) {
                            let source = document.createElement("source");
                            source.type = "video/ogg";
                            source.src = ogv;
                            video.appendChild(source);
                        }

                        // Ajout de l'autoplay
                        video.controls = false;
                        video.autoplay = true;
                        video.muted;
                        video.preload;
                        video.loop = true;
                        video.loop;
                        video.setAttribute("loop", "loop");
                        video.setAttribute("muted", "muted");

                        //ajout de l'auto play
                        video.oncanplay = (e) => {
                            try {

                                e.target.muted = true;

                                if (e.target.parentNode.parentNode.classList.contains('video_container')) {
                                    e.target.currentTime = e.target.duration;
                                    e.target.pause();
                                } else {
                                    e.target.play();
                                }


                            } catch (ex) {
                                console.error(error);
                            }
                        }

                        return video;

                    }
                    return false;
                }


                /**
                 * ajout le conteneur d'affichage de la video dans les images de produit
                 */
                function addVideoToproductPicture() {

                    let videoT = document.querySelector(".video_container>span>video");

                    if (videoT) {

                        var productsCover = document.querySelectorAll(".product-cover");

                        productsCover.forEach((productCover) => {

                            let div = document.createElement('div');
                            div.style.width = "100%";
                            div.style.height = "100%";
                            div.style.display = "none";
                            div.style.position = "absolute";
                            div.style.top = "0";
                            div.style.right = "0";
                            div.style.bottom = "0";
                            div.style.left = "0";
                            div.style.background = "black";
                            div.classList.add("digitalsignage_video_displayer");

                            div.appendChild(videoT.cloneNode(true));

                            productCover.appendChild(div);

                        });

                    }

                }

                function addCustomProductPictureStyle() {
                    var styles = `

                                    .video_container.select{
                                        border: 3px solid #2fb5d2;
                                    }

                                   .video_container.gg-play-button.select:hover {
                                      border: 0;
                                    }

                                    .video_container span{
                                        width : 100%;
                                        height: 100%;
                                    }
                                      .video_container span video{
                                        height: 100%;
                                    }
                                    .gg-play-button {
                                        position: relative;
                                    }

                                    .gg-play-button::before {
                                        content: "";
                                        position: absolute;
                                        border-top: 23px solid transparent;
                                        border-bottom: 23px solid transparent;
                                        border-left: 40px solid;
                                        color: #fffffff2;
                                        margin-left: 53%;
                                        margin-top: 50%;
                                        transform: translateX(-50%) translateY(-50%);
                                    }
                                `;

                    var styleSheet = document.createElement("style");
                    styleSheet.type = "text/css";
                    styleSheet.innerText = styles;
                    document.head.appendChild(styleSheet);
                }

                var videosProduit = document.querySelectorAll(".thumb .video_container span video");

                videosProduit.forEach(function (video) {
                    video.classList.add('ds4_video');
                    video.style.opacity = "0";
                });


                document.body.addEventListener('click', (event) => {

                    if (event.target.classList.contains('ds4_video')) {

                        if (event.target.parentNode.parentNode.classList.contains('video_container')) {
                            //clic sur l'icon video dans les images
                            let productsCover = document.querySelectorAll(".digitalsignage_video_displayer");
                            productsCover.forEach((productCover) => {

                                productCover.firstChild.currentTime = 0;
                                productCover.firstChild.play();
                                productCover.style.display = "flex";

                            });

                            document.querySelector(".thumb > .video_container").classList.add("select") ;

                        }
                    } else if (event.target.classList.contains('thumb')) {
                        //clic sur un autre icon que l'icon video dans les image

                        let productsCover = document.querySelectorAll(".digitalsignage_video_displayer");

                        productsCover.forEach((productCover) => {
                            productCover.style.display = "none";
                        });

                        document.querySelector(".thumb > .video_container").classList.remove("select") ;

                    }

                });

                document.querySelector(".ds4_video").click();

            </script>

            <?php
        $js = ob_get_clean();

        return $description_short . $js;
    }
}
